#include "mbed.h"
#include <string>
#include "string.h"

Serial SIM800(PA_9, PA_10);
Serial pc(USBTX, USBRX);

string result;
char x;
string recievedSMS;
int telNum = 608722891;         //Tel. cislo pro odpovedi
string sendMSG;
string cmti ("CMTI"); 
string strON ("systemON");      //prikaz pro zapnuti systemu
string strOFF ("systemOFF");    //prikaz pro vypnuti systemu
string authTEL ("608722891");   //Povolene Tel. cislo


bool message_received;
bool activeA1 = false;
bool activeA2 = false;



void clearString(){
    result.clear();
}
 
void callback_rx() {
    while (SIM800.readable()) {
        x = SIM800.getc();
        result += x;
        pc.putc(x); // vypise odpoved GSM do PC
 
       }
      
}
 
void send_SMS(string message){
    SIM800.printf("AT+CMGF=1\r\n");
    wait_ms(1000);
    wait_ms(1000);
    SIM800.printf("AT+CMGS=");
    SIM800.putc('"');
    SIM800.printf("%u",telNum);
    SIM800.putc('"');
    SIM800.printf("\r");
    SIM800.printf("\n");
    wait_ms(1000);
    SIM800.printf("%s",message);
    wait_ms(1000);
    SIM800.putc(0x1A);
    wait_ms(1000);
}

void receive_sms()
{
    wait(0.25);
    SIM800.printf("AT+CMGF=1%c", 13);
    wait(0.25);
    //sms.printf("AT+CMGL=\"ALL\"%c", 13);
    SIM800.printf("AT+CMGL=\"REC UNREAD\"%c", 13);
    wait(5);
    recievedSMS = result;
}

void delete_messages()
{
    wait(0.25);
    SIM800.printf("AT+CMGF=1%c", 13);
    wait(0.25);
    SIM800.printf("AT+CMGD=1,4%c", 13);
    wait(2);
}

void GSM_init()
{  
  // check if GSM is fine
    SIM800.printf("AT\r");                     
    wait(1);
    pc.printf("\nGSM Working fine\n");
    wait(1);
    
    //no echo
    SIM800.printf("ATE0\r");
    wait(1);
    pc.printf("\nEcho Switched off\n");
    wait(1);
    
    //network reg
    SIM800.printf("AT+CREG?\r");
    wait(1);
    pc.printf("\nNetwork Registered\n"); 
    wait(1);
    //Service provider
    pc.printf("\nNetwork Provider\n"); 
    SIM800.printf("AT+CGMI\r");
    wait(1);
}
 
void sms_init(){
    SIM800.printf("AT+CMGF=1\r");
    wait(1);
    pc.printf("\nGSM SMS set to Text Mode\n");
    wait(1);
    //delete all previous messages  
    SIM800.printf("AT+CMGD=1,4\r");
    wait(1);
    pc.printf("\nAll previous messages cleared \n");
    message_received = false;
}

void msg_parse(){  
     if (recievedSMS.find(authTEL) != string::npos){
            if (recievedSMS.find(strON) != string::npos){
                activeA1 = true;
                activeA2 = true;
                pc.printf("\nSystem se aktivuje!");
                sendMSG = "System se aktivuje!";
                send_SMS(sendMSG);
                }
            else if (recievedSMS.find(strOFF) != string::npos){
                activeA1 = false;
                activeA2 = false;
                pc.printf("\nSystem se vypne!");
                sendMSG = "System se vypne!";    
                send_SMS(sendMSG);
                }
            else {
                pc.printf("\nNeznamy prikaz!");
                sendMSG = "Neznamy prikaz!";    
                send_SMS(sendMSG);
                }
    } else {
            pc.printf("\nNeautorizovany uzivatel!");
            sendMSG = "Pozor! Neautorizovany pristup k zarizeni!";    
            send_SMS(sendMSG);
            }      
                
    message_received = false;
    clearString();
    delete_messages();
            
}

void recieve_and_parse_SMS(){
    if (result.find(cmti) != string::npos){
        receive_sms();            
        wait(5);
        message_received = true;
        }        
    if(message_received){
        msg_parse();
    }    
}

void setup_GSM(){
    SIM800.attach(&callback_rx);
    SIM800.baud(9600); //
    GSM_init();
    sms_init();
    clearString();
    wait_ms(100);    
}