#include "mbed.h"
#include "gsm.h"
#include "PinDetect.h"
#include "LiquidCrystal_I2C.h"
#include "string.h"
#include <string>
//Serial pc(USBTX, USBRX); //tx, rx

LiquidCrystal_I2C lcd(0x4E, 16, 2); // 0x27 pro 16 znaku and 2 radky, 0x4E

DigitalOut ledGreenA1(D9);
DigitalOut ledRedA1(D10);
DigitalOut ledGreenA2(D12);
DigitalOut ledRedA2(D11);

PinDetect buttonA1(D7);
PinDetect buttonA2(D6);



DigitalIn pir1(A0);
DigitalIn pir2(A1);
int PIR_1_value;
int PIR_2_value;
int PIR_1_name = 1;
int PIR_2_name = 2;

DigitalIn switchDoor1(A3,PullUp);
DigitalIn switchDoor2(A4,PullUp);
DigitalIn switchDoor3(A5,PullUp);
int switch_1_value;
int switch_2_value;
int switch_3_value;
int switch_1_name = 1;
int switch_2_name = 2;
int switch_3_name = 2;


char usSensorAddress1=0xE0;
int usSensorName1=1;

//---------------------Ovladaci tlacitka------------------------
void leds(){
        ledGreenA1 = activeA1; 
        ledRedA1 = !ledGreenA1;
        ledGreenA2 = activeA2; 
        ledRedA2 = !ledGreenA2;   
}

void buttonA1_hit_callback (void) {
        activeA1 = !activeA1;
        if(!activeA1){
            activeA2 = false;
            }
        leds();    
}
            
void buttonA2_hit_callback (void) {
        activeA2 = !activeA2;
        if(activeA2){
            activeA1 = true;
            }
        leds();
}   

//-----------------------Ultrazvuk senzor-----------------------

I2C sensor(D14,D15); // SDA, SCL

int getDistanceCm(char adresaUS){
char w_addr_ = adresaUS; // nastavení zapisovací adresy senzoru
char r_addr_ = w_addr_ + 1; //nastavení čtecí adresy
char data[2];
 // poslání CM příkazu do příkazového registru
    data[0] = 0x00; //CMD_REG
    data[1] = 0x51; //měření v CM
int ack = sensor.write(w_addr_,data,2);
    wait_ms(70);
char reg = 0x02; //nejvyšší byte
    ack = sensor.write(w_addr_,&reg,1);
    ack = sensor.read(r_addr_,data,2);
return (data[0] << 8) | data[1]; //bitový posun
}


void naruseniUS(char usSensorAdress,int usSensorName){
    
    int dist1 = getDistanceCm(usSensorAdress);
    wait(0.01);
    int dist2 = getDistanceCm(usSensorAdress);
    int rozdil;
    int rozdilVal = 30;
    rozdil = abs(dist1 - dist2);

    string US_msg;
    char buffer [50];
    sprintf(buffer,"Zaznamenan narusitel! Senzor: Ultrazvuk %d",usSensorName);
   

    if(rozdil > rozdilVal){
        pc.printf("\n%s\n",buffer);
        lcd.print("NARUSITEL US"); 
        send_SMS(buffer);
        wait(3); 
        lcd.clear();
    }
}

//-------------------------PIR senzor---------------------------

void naruseniPIR(int pirSensorVal, int pirSensorName){
    int pirSensor = pirSensorVal;
    string PIR_msg;
    char buffer [50];
    sprintf(buffer,"Zaznamenan narusitel! Senzor: PIR A%d",pirSensorName);
   
    if(pirSensor){
        pc.printf("\n%s\n",buffer);
        lcd.print("NARUSITEL PIR"); 
        send_SMS(buffer);
        wait(3);
        lcd.clear();
    }

}

//-----------------------SPINAC senzor--------------------------

void naruseniSwitch(int switchSensorVal,int switchSensorName){
    int switchSensor = switchSensorVal;
    string Switch_msg;
    char buffer [50];
    sprintf(buffer,"Zaznamenan narusitel! Senzor: Switch %d",switchSensorName);
    
    if(switchSensor){
        pc.printf("\n%s\n",buffer);
        lcd.print("NARUSITEL SWITCH"); 
        send_SMS(buffer);     
        wait(3);
        lcd.clear();

    }
    
}

//----------------------SETUP ZARIZENI-------------------------

void setup_devices()
{
    // ----Inicializace tlacitek----
    // Use internal pullup for pushbutton
    buttonA1.mode(PullUp);
    buttonA2.mode(PullUp);
    // Delay for initial pullup to take effect
    wait(.01);
    // Setup Interrupt callback function for a buttonA1 hit
    buttonA1.attach_deasserted(&buttonA1_hit_callback);
    buttonA2.attach_deasserted(&buttonA2_hit_callback);
    // Start sampling buttonA1 input using interrupts
    buttonA1.setSampleFrequency();
    buttonA2.setSampleFrequency();
    // ----Inicializace displaye----
    lcd.begin();
    lcd.backlight();
    lcd.print("START LCD");
    wait(2);
    lcd.clear();
    // ----Inicializace GSM modulu----
    setup_GSM();
}